#include "Composed/Div_SW/Div_SWRJ__Channel_1.h"
char * Div_SWRJ__Channel_1__SharedNames[] = {"Attack_enabled", "CCF_active", "CH_OK", "C_attack_enabled", "Channel_attacked_ID", "ConfigurationOK", "Safe_state", "System_OK", "Unsafe_state_2"};

Div_SWRJ__Channel_1::Div_SWRJ__Channel_1():Join("Channel_1", 3, 9,Div_SWRJ__Channel_1__SharedNames) {
  SW_channel_1 = new SW_channelSAN();
  ModelArray[0] = (BaseModelClass*) SW_channel_1;
  ModelArray[0]->DefineName("SW_channel_1");
  configuration_channel_1 = new configuration_channelSAN();
  ModelArray[1] = (BaseModelClass*) configuration_channel_1;
  ModelArray[1]->DefineName("configuration_channel_1");
  Control_conf_channel_1 = new Control_configuration_channelSAN();
  ModelArray[2] = (BaseModelClass*) Control_conf_channel_1;
  ModelArray[2]->DefineName("Control_conf_channel_1");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    Attack_enabled = new Place("Attack_enabled");
    addSharedPtr(Attack_enabled, "Attack_enabled" );
    if (configuration_channel_1->NumStateVariables > 0) {
      Attack_enabled->ShareWith(configuration_channel_1->Attack_in_progress);
      addSharingInfo(configuration_channel_1->Attack_in_progress, Attack_enabled, configuration_channel_1);
    }

    //Shared variable 1
    CCF_active = new Place("CCF_active");
    addSharedPtr(CCF_active, "CCF_active" );
    if (SW_channel_1->NumStateVariables > 0) {
      CCF_active->ShareWith(SW_channel_1->CCF_active);
      addSharingInfo(SW_channel_1->CCF_active, CCF_active, SW_channel_1);
    }

    //Shared variable 2
    CH_OK = new Place("CH_OK");
    addSharedPtr(CH_OK, "CH_OK" );
    if (SW_channel_1->NumStateVariables > 0) {
      CH_OK->ShareWith(SW_channel_1->Channel_OK);
      addSharingInfo(SW_channel_1->Channel_OK, CH_OK, SW_channel_1);
    }
    if (Control_conf_channel_1->NumStateVariables > 0) {
      CH_OK->ShareWith(Control_conf_channel_1->OK_state);
      addSharingInfo(Control_conf_channel_1->OK_state, CH_OK, Control_conf_channel_1);
    }

    //Shared variable 3
    C_attack_enabled = new Place("C_attack_enabled");
    addSharedPtr(C_attack_enabled, "C_attack_enabled" );
    if (Control_conf_channel_1->NumStateVariables > 0) {
      C_attack_enabled->ShareWith(Control_conf_channel_1->Attack_in_progress);
      addSharingInfo(Control_conf_channel_1->Attack_in_progress, C_attack_enabled, Control_conf_channel_1);
    }

    //Shared variable 4
    Channel_attacked_ID = new Place("Channel_attacked_ID");
    addSharedPtr(Channel_attacked_ID, "Channel_attacked_ID" );
    if (configuration_channel_1->NumStateVariables > 0) {
      Channel_attacked_ID->ShareWith(configuration_channel_1->Channel_attacked_ID);
      addSharingInfo(configuration_channel_1->Channel_attacked_ID, Channel_attacked_ID, configuration_channel_1);
    }

    //Shared variable 5
    ConfigurationOK = new Place("ConfigurationOK");
    addSharedPtr(ConfigurationOK, "ConfigurationOK" );
    if (SW_channel_1->NumStateVariables > 0) {
      ConfigurationOK->ShareWith(SW_channel_1->Configuration_state);
      addSharingInfo(SW_channel_1->Configuration_state, ConfigurationOK, SW_channel_1);
    }
    if (configuration_channel_1->NumStateVariables > 0) {
      ConfigurationOK->ShareWith(configuration_channel_1->Correct);
      addSharingInfo(configuration_channel_1->Correct, ConfigurationOK, configuration_channel_1);
    }
    if (Control_conf_channel_1->NumStateVariables > 0) {
      ConfigurationOK->ShareWith(Control_conf_channel_1->Configuration_state);
      addSharingInfo(Control_conf_channel_1->Configuration_state, ConfigurationOK, Control_conf_channel_1);
    }

    //Shared variable 6
    Safe_state = new Place("Safe_state");
    addSharedPtr(Safe_state, "Safe_state" );
    if (SW_channel_1->NumStateVariables > 0) {
      Safe_state->ShareWith(SW_channel_1->Safe_state);
      addSharingInfo(SW_channel_1->Safe_state, Safe_state, SW_channel_1);
    }
    if (Control_conf_channel_1->NumStateVariables > 0) {
      Safe_state->ShareWith(Control_conf_channel_1->Safe_failure);
      addSharingInfo(Control_conf_channel_1->Safe_failure, Safe_state, Control_conf_channel_1);
    }

    //Shared variable 7
    System_OK = new Place("System_OK");
    addSharedPtr(System_OK, "System_OK" );
    if (SW_channel_1->NumStateVariables > 0) {
      System_OK->ShareWith(SW_channel_1->System_OK);
      addSharingInfo(SW_channel_1->System_OK, System_OK, SW_channel_1);
    }

    //Shared variable 8
    Unsafe_state_2 = new Place("Unsafe_state_2");
    addSharedPtr(Unsafe_state_2, "Unsafe_state_2" );
    if (SW_channel_1->NumStateVariables > 0) {
      Unsafe_state_2->ShareWith(SW_channel_1->Unsafe_state_2);
      addSharingInfo(SW_channel_1->Unsafe_state_2, Unsafe_state_2, SW_channel_1);
    }
    if (Control_conf_channel_1->NumStateVariables > 0) {
      Unsafe_state_2->ShareWith(Control_conf_channel_1->Unsafe_state_2);
      addSharingInfo(Control_conf_channel_1->Unsafe_state_2, Unsafe_state_2, Control_conf_channel_1);
    }

  }

  Setup();
}

Div_SWRJ__Channel_1::~Div_SWRJ__Channel_1() {
  if (!AllChildrenEmpty()) {
    delete Attack_enabled;
    delete CCF_active;
    delete CH_OK;
    delete C_attack_enabled;
    delete Channel_attacked_ID;
    delete ConfigurationOK;
    delete Safe_state;
    delete System_OK;
    delete Unsafe_state_2;
  }
  delete SW_channel_1;
  delete configuration_channel_1;
  delete Control_conf_channel_1;
}
